#include "OGLWidgetFloating.h"
#include "VisibleForm.h"
#include <qimage.h>

VisibleForm *fwin_pForm;
char			fwin_qstr[128];		// String for onscreen text

//calbak: display text
void text(char* string, void *font ) {
    char* p;
    for(p=string;*p;p++) {
        glutBitmapCharacter(font,*p);
    }
}

//calbak: show string
//
void showOnScreenText() {
    double xpos=0.0;
    double ypos=0.0;
    double delta=0.07;
    
    glPushAttrib(GL_CURRENT_BIT | GL_LIGHTING_BIT);
    glDisable(GL_LIGHTING);
    
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    gluOrtho2D(-1.2,1.2,-1.2,1.2);

    glMatrixMode(GL_MODELVIEW);
    glDisable(GL_LIGHTING);

    xpos=-1.0;
    ypos=-1.0;
       

	if(fwin_pForm->mo->objectID==OBJCURVE) {
		if(fwin_pForm->swapFrames) {
			glColor3f(0.5f,0.0f,0.0f);
			sprintf(fwin_qstr,"Quaternion Map");
			glRasterPos2f(xpos,ypos);
			text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);
			xpos = -0.5;
            
			if(fwin_pForm->mo->whichFrame==PARALLELTRANSPORT){
				sprintf(fwin_qstr,": of PARALLEL TRANSPORT frame");
			}
			else if(fwin_pForm->mo->whichFrame==FRENETSERRET){
				sprintf(fwin_qstr,": of FRENET-SERRET frame");
			}
			else if(fwin_pForm->mo->whichFrame==GEODESICREFERENCE){
				sprintf(fwin_qstr,": of GEODESIC REFERENCE frame");
			}
			glRasterPos2f(xpos,ypos);
			text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);
				//sprintf(fwin_qstr,"Quaternion Map of Frames on Belt:");
				//glRasterPos2f(xpos,ypos);
				//text(fwin_qstr);
				//if(!hasFocus()) {
				//	xpos+=15.0*delta;
				//	glColor3f(0.7f,0.0f,0.0f);
				//	sprintf(fwin_qstr,"Click to focus...");
				//	glRasterPos2f(xpos,ypos);
				//	text(fwin_qstr);
				//}
			xpos = -1.0;
			glColor3f(0.0f,0.0f,0.3f);
			ypos-=delta;
			switch(fwin_pForm->mo->qwhichQuatComponent) {
				case SHOWXYZ:
					sprintf(fwin_qstr,"Components Projected = XYZ");
					break;
				case SHOWWYZ:
					sprintf(fwin_qstr,"Components Projected = WYZ");
					break;
				case SHOWWXZ:
					sprintf(fwin_qstr,"Components Projected = WXZ");
					break;
				case SHOWWXY:
					sprintf(fwin_qstr,"Components Projected = WXY");
					break;
				default:
					break;
			}
			glRasterPos2f(xpos,ypos);
			text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);
			
			//glColor3f(0.0f,0.0f,0.0f);
			//ypos-=delta;
			//sprintf(fwin_qstr,"Curve PT Angle: %f",fwin_pForm->mo->curveQuatAngle_PT );
			//glRasterPos2f(xpos,ypos);
			//text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);

			//glColor3f(0.0f,0.0f,0.0f);
			//ypos-=delta;
			//sprintf(fwin_qstr,"Quat distance: %f, angle: %f",fwin_pForm->mo->curveQuatDistance,fwin_pForm->mo->curveQuatAngle);
			//glRasterPos2f(xpos,ypos);
			//text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);

			//glColor3f(0.0f,0.0f,0.0f);
			//ypos-=delta;
			//sprintf(fwin_qstr,"Optimization: ERROR: %f",fwin_pForm->mo->opt_ERROR);
			//glRasterPos2f(xpos,ypos);
			//text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);

			//glColor3f(0.0f,0.0f,0.3f);
			//ypos-=delta;
			//sprintf(fwin_qstr,"error = DIFF(Current and PT Frame): %f",fwin_pForm->mo->opt_ERROR );
			//glRasterPos2f(xpos,ypos);
			//text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);

		}
		else {
			glColor3f(0,0,0);
			sprintf(fwin_qstr,"Quaternion Map");
			glRasterPos2f(xpos,ypos);
			text(fwin_qstr,GLUT_BITMAP_HELVETICA_12);
		}
	}
	else if(fwin_pForm->mo->objectID==OBJSURFACE) {
		if(fwin_pForm->swapFrames) {
			glColor3f(0,0,0);
			sprintf(fwin_qstr,"Map of Normals");
			glRasterPos2f(xpos,ypos);
			text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);
			//xpos = -0.5;
			//if(fwin_pForm->mo->whichFrame==PARALLELTRANSPORT){
			//	sprintf(fwin_qstr,": of PARALLEL TRANSPORT frame");
			//}
			//else if(fwin_pForm->mo->whichFrame==FRENETSERRET){
			//	sprintf(fwin_qstr,": of FRENET-SERRET frame");
			//}
			//glRasterPos2f(xpos,ypos);
			//text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);
			//	//sprintf(fwin_qstr,"Quaternion Map of Frames on Belt:");
			//	//glRasterPos2f(xpos,ypos);
			//	//text(fwin_qstr);
			//	//if(!hasFocus()) {
			//	//	xpos+=15.0*delta;
			//	//	glColor3f(0.7f,0.0f,0.0f);
			//	//	sprintf(fwin_qstr,"Click to focus...");
			//	//	glRasterPos2f(xpos,ypos);
			//	//	text(fwin_qstr);
			//	//}
			//xpos = -1.0;
			//glColor3f(1.0f,1.0f,0.2f);
			//ypos-=delta;
			//switch(fwin_pForm->mo->qwhichQuatComponent) {
			//	case SHOWXYZ:
			//		sprintf(fwin_qstr,"Components Projected = XYZ");
			//		break;
			//	case SHOWWYZ:
			//		sprintf(fwin_qstr,"Components Projected = WYZ");
			//		break;
			//	case SHOWWXZ:
			//		sprintf(fwin_qstr,"Components Projected = WXZ");
			//		break;
			//	case SHOWWXY:
			//		sprintf(fwin_qstr,"Components Projected = WXY");
			//		break;
			//	default:
			//		break;
			//}
			//glRasterPos2f(xpos,ypos);
			//text(fwin_qstr,GLUT_BITMAP_HELVETICA_18);
		}
		else {
			glColor3f(0.95f,0.95f,0.95f);
			sprintf(fwin_qstr,"Map of Normals");
			glRasterPos2f(xpos,ypos);
			text(fwin_qstr,GLUT_BITMAP_HELVETICA_12);
		}
	}

	glMatrixMode(GL_PROJECTION);   
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glPopAttrib();
}


//calbak: CONSTRUCTOR
//
OGLWidgetFloating::OGLWidgetFloating( QWidget* parent, const char* name, QWidget* parentForm)
        : QGLWidget( parent, name)
{
    fwin_pForm = (VisibleForm*) parentForm;
    init();
}

//calbak: ~DESTRUCTOR
//
OGLWidgetFloating::~OGLWidgetFloating() 
{
    fwin_pForm = NULL;
}


//calbak: INIT GL
//
void OGLWidgetFloating::initializeGL () 
{
    //glClearColor(0.23,0.5,0.65,1.0);
	glClearColor(0.7,0.725,0.7,1.0);
	//glClearColor(1,1,1,1.0);
    initLighting();
    m_viewScale = 1.0;
}

//calbak: my init
//
void OGLWidgetFloating::init ( void )
{
	// workspace center
    X=0; Y=0; dX=0; dY=0;
    XC = 0.0; YC = 0.0; ZC = -10.0;
    Cx = 0.0; Cy = 0.0; Cz = 0.0;

        // mouse stuff
    mouseButtons	= 0;
    button			= 0;
    mouseModifiers	= 0;

	// viewport dimensions
    xMin			= -1.0;
    xMax			=  1.0;
    yMin			= -1.0;
    yMax			=  1.0;
    zNear			=  5.0;
    zFar			= 25.0;

    main_height		= this->height();
    main_width		= this->width();
}

//calbak: my init lighting
//
void OGLWidgetFloating::initLighting ( void ) 
{
    //static const GLfloat light_model_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light0_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light0_diffuse[]	= {0.9f, 0.9f, 0.9f, 0.9f};  
    //static const GLfloat light0_specular[]	= {1.0f, 1.0f, 1.0f, 1.0f};
    //static const GLfloat light0_shininess[]	= {100.0};
    //static const GLfloat light0_direction[]	= {0.0f, 0.0f, 10.0f, 0.0f};    
    //
    //static const GLfloat light1_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    //static const GLfloat light1_diffuse[]	= {0.9f, 0.0f, 0.0f, 0.9f};  
    //static const GLfloat light1_specular[]	= {1.0f, 1.0f, 1.0f, 1.0f};
    //static const GLfloat light1_shininess[]	= {300.0};
    //static const GLfloat light1_direction[]	= {0.0f, 0.0f, 10.0f, 0.0f};    
    //
    //global_light0[0]=light0_direction[0];
    //global_light0[1]=light0_direction[1];
    //global_light0[2]=light0_direction[2];
    //global_light0[3]=light0_direction[3];
    //
    //    /* Enable depth buffering for hidden surface removal. */
    //glDepthFunc(GL_LEQUAL);
    //glEnable(GL_DEPTH_TEST);
    //
    //    /* Other misc features. */
    //glEnable(GL_LIGHTING);
    //glEnable(GL_NORMALIZE);
    //glShadeModel(GL_SMOOTH);
    //
    //glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
    //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);    
    //glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_model_ambient);

    //glLightfv(GL_LIGHT0, GL_DIFFUSE,   light0_diffuse);
    //glLightfv(GL_LIGHT0, GL_POSITION,  light0_direction);
    //glLightfv(GL_LIGHT0, GL_AMBIENT,   light0_ambient);
    //glLightfv(GL_LIGHT0, GL_SPECULAR,  light0_specular);
    //glLightfv(GL_LIGHT0, GL_SHININESS, light0_shininess);
    //glEnable(GL_LIGHT0);     

    //glLightfv(GL_LIGHT1, GL_DIFFUSE,  light1_diffuse);
    //glLightfv(GL_LIGHT1, GL_POSITION, light1_direction);
    //glLightfv(GL_LIGHT1, GL_AMBIENT,  light1_ambient);
    //glLightfv(GL_LIGHT1, GL_SPECULAR, light1_specular);
    //glLightfv(GL_LIGHT1, GL_SHININESS,light1_shininess);
	
    //glEnable(GL_LIGHT0);    
	float s[4];
	float ltc[4],ltp[4];
    ltp[0] = 0.0; ltp[1] = 0.1; ltp[2] = 1.0; ltp[3] = 0.0;
    ltc[0] = 1.0; ltc[1] = 1.0; ltc[2] = 1.0; ltc[3] = 1.0;

    static const GLfloat light_model_ambient[]	= {0.3f, 0.3f, 0.3f, 1.0f};
    static const GLfloat light0_ambient[]		= {0.3f, 0.3f, 0.3f, 1.0f};
    static const GLfloat light0_diffuse[]		= {0.9f, 0.9f, 0.9f, 0.9f};  
    static const GLfloat light0_specular[]		= {0.0f, 0.0f, 0.0f, 1.0f};
    static const GLfloat light0_shininess[]		= {100.0};
    static const GLfloat light0_direction[]		= {0.0f, 0.0f, 10.0f, 1.0f};    
    
    global_light0[0]=light0_direction[0];
    global_light0[1]=light0_direction[1];
    global_light0[2]=light0_direction[2];
    global_light0[3]=light0_direction[3];
    
    s[0] = fwin_pForm->mo->mats[0] * fwin_pForm->mo->specular;
    s[1] = fwin_pForm->mo->mats[1] * fwin_pForm->mo->specular;
    s[2] = fwin_pForm->mo->mats[2] * fwin_pForm->mo->specular;
    s[3] = 1.0;

    glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);
    
    /* Other misc features. */
    glEnable(GL_LIGHTING);
    glEnable(GL_NORMALIZE);
    glShadeModel(GL_SMOOTH);
    
    s[0] = fwin_pForm->mo->mats[0] * fwin_pForm->mo->specular;
    s[1] = fwin_pForm->mo->mats[1] * fwin_pForm->mo->specular;
    s[2] = fwin_pForm->mo->mats[2] * fwin_pForm->mo->specular;
    s[3] = 1.0;

    glMaterialfv (GL_FRONT_AND_BACK,GL_AMBIENT,fwin_pForm->mo->mata);
    glMaterialfv (GL_FRONT_AND_BACK,GL_DIFFUSE,fwin_pForm->mo->matd);
    glMaterialfv (GL_FRONT_AND_BACK,GL_SPECULAR,fwin_pForm->mo->mats);
    glMaterialf  (GL_FRONT_AND_BACK,GL_SHININESS,fwin_pForm->mo->shininess);

    glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);    
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, light_model_ambient);
    glEnable     (GL_LIGHTING);

    glLightfv    (GL_LIGHT0,GL_POSITION,ltp);
	glLightfv    (GL_LIGHT0,GL_DIFFUSE,ltc);
    glEnable     (GL_LIGHT0);
    glEnable     (GL_NORMALIZE);
}

//calbak: my reset application
//
void OGLWidgetFloating::resetApp ( void )
{
    m_viewScale = 1.0;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glScalef(m_viewScale, m_viewScale, m_viewScale);//@ scale factor
    glTranslatef(XC,YC,ZC);
}

//calbak: RESIZE GL
//
void  OGLWidgetFloating::resizeGL( int wd, int ht )
{
    int w = wd;
    int h = ht;

    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    glFrustum(xMin, xMax, yMin, yMax, zNear, zFar);
/* Viewing location of camera */
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(XC,YC,ZC);

}

//calbak: MOUSE-BUTTON PRESS
//
void OGLWidgetFloating::mousePressEvent			( QMouseEvent *e )
{
    QMouseEvent *m = e;
    int x = m->x();
    int y = m->y();

    setFocus();
    
    X = x;
    Y =  main_height -y - 1;

    //switch (m->button()){
    //    case  LeftButton:
    //        button = 0x1; /* our Left   bit code */
    //        break;
    //    case MidButton:
    //        button = 0x2; /* our Middle bit code */
    //        break;
    //    case RightButton:
    //        button = 0x4; /* our Right  bit code */
    //        break;
    //    default:
    //        break;
    //}

    //mouseButtons |= button;
    //
    //    //Check if a vertex is lit
    //if(button == 0x1){
    //    if(litVertex == -1){
    //            //if(draw_curve==OBJSPLINE) {
    //            //             //if not, add a new vertex
    //            //             printf("mouse clicked at (%d,%d)\n",X,Y);
    //            //             addPoint(X,Y);
    //            //         }
    //    }
    //    else{
    //            //printf("litVertex = %d\n",litVertex);
    //        movingPoint = TRUE;
    //    }   
    //}

    //updateGL();
}

//calbak: MOUSE-BUTTON PRESS
//
void OGLWidgetFloating::mouseDoubleClickEvent	( QMouseEvent *e ) 
{
    QMouseEvent *l_e = e;
    l_e = NULL;
    fwin_pForm->calbak_Swap_Frames();
}
//calbak: MOUSE-BUTTON RELEASE
//
void OGLWidgetFloating::mouseReleaseEvent		( QMouseEvent *e )
{
    QEvent *ev = e;
    ev = NULL;
    
    mouseButtons &= (~(button));
    if(button == 0x1){
        movingPoint = FALSE;
    }
}

//calbak: move points
//
void OGLWidgetFloating::moveTransformedCoordinate(float x, float y)
{
    float l_x = x;
    float l_y = y;
    l_x = 0;
    l_y = 0;

}
//calbak: MOUSE MOVE
//
void OGLWidgetFloating::mouseMoveEvent			( QMouseEvent *e )
{
    QMouseEvent *m = e;
    int		x = m->x();
    int		y = m->y();
    double	deltaY	= 0.0;
    double	deltaX	= 0.0;
    int		nHatX	= 0;
    int		nHatY	= 0;
    double	thetaRad = 0.0;
    double	thetaDeg = 0.0;
    double	radius	 = 250.0;
    double	drSquared= 0.0;
    float	modelviewMatrix[16];
    
        //@ scaling
    double	y1=0.0;
    double	y2=0.0;
        //@@
    
    xBegin = X;
    yBegin = Y;
    startY = Y;
    X = x;
    Y =  main_height - y - 1;	/* Invert to right-handed system */

        //@ scaling objects
    y1 = (double)yBegin;
    y2 = (double)Y;
        //@@

    xNext = X;
    yNext = Y;

        // Passive motion callback is simulate here with the
        // boolean movingPoint
        //if((enable_picking) && (draw_curve==OBJSPLINE) && (!movingPoint)) {
        //    mousePickVertex(x,y);
        //}
    
        //case 0x1:  /* Middle Mouse Button   */
    if(m->state()==MidButton) {
        
        if(movingPoint == TRUE && litVertex > -1){
                //flagPointMoved = 1;
            if(mouseModifiers != GLUT_ACTIVE_SHIFT){
                moveTransformedCoordinate(X,Y);
            }
            else{
                    //shift is pressed so move in Z
                deltaY = Y - (int)startY;
                zCoord[litVertex] = zCoord[litVertex] - (float)deltaY/20.0;
                if(zCoord[litVertex] > zNear){
                    zCoord[litVertex] = zNear;
                }
                if(zCoord[litVertex] < (zNear - (zFar - zNear))){
                    zCoord[litVertex] =(zNear - (zFar - zNear)) ;
                }
            }
        }
    }
    
        //case 0x2:  /* Left Mouse Button - ROTATE OBJECT */
    if(m->state()==LeftButton){

        deltaX = xNext - xBegin;
        deltaY = yNext - yBegin;
        nHatX = (int)-deltaY;
        nHatY = (int)deltaX;
            //get the amount of rotation
        drSquared = pow(deltaX,2) + pow(deltaY,2);
        thetaRad = acos(radius/(sqrt(pow(radius,2) + drSquared)));
        thetaDeg = (thetaRad * 180) / M_PI;
            //translate to center
        glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        glTranslatef(XC,YC,ZC);
        glTranslatef(Cx, Cy, 0);
            
        glRotatef(thetaDeg,nHatX,nHatY,0);
            //tranlsate back
        glTranslatef(-Cx, -Cy, 0);
        glTranslatef(-XC,-YC,-ZC);
        glMultMatrixf(modelviewMatrix);

        
    }
    
        //case 0x4:  /* Right Mouse Button  */
        //translating
    if( (m->state() & RightButton) && (m->state() & ShiftButton)) {
        
        glGetFloatv(GL_MODELVIEW_MATRIX,modelviewMatrix);
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        glTranslatef(((float)xNext-xBegin)/((float)main_width/2.0),
                     ((float)yNext-yBegin)/((float)main_height/2.0),0);
        glMultMatrixf(modelviewMatrix);

        
        Cx = Cx + ((float)xNext-xBegin)/((float)main_width/2.0);
        Cy = Cy + ((float)yNext-yBegin)/((float)main_height/2.0);
    }
    else  if((m->state() & RightButton) && !(m->state() & ShiftButton))//scaling
    {
        m_viewScale *= 1 + (y2 - y1)/((double)main_height*10.0);
        if(m_viewScale<0.1)
            m_viewScale=0.1;
        if(m_viewScale>6.0)
            m_viewScale=6.0;
    }  

    updateGL();
}

//calbak: KYBOARD-BUTTON PRESS
//
void OGLWidgetFloating::keyPressEvent			( QKeyEvent *e )
{
    QMessageBox mb( "Exiting...",
                    "Really quit?",
                    QMessageBox::NoIcon,
                    QMessageBox::Yes | QMessageBox::Default,
                    QMessageBox::No,QMessageBox::NoButton );

    switch(e->key()) {

        case Key_Space:
            break;
        
        case Key_H:
            if(e->state()&&ShiftButton) {
				fwin_pForm->mo->showOnScreenHelp = !fwin_pForm->mo->showOnScreenHelp;
			}
			else {
				fwin_pForm->calbak_Help();
			}
            break;
        case Key_A:
            fwin_pForm->mo->qshowAxes = !fwin_pForm->mo->qshowAxes;
            break;
            
        case Key_B:
                //currentSpline = BSPLINE;
                //whichSpline = BSPLINE;
            break;
            
        case Key_C:
            fwin_pForm->mo->qshowCurve = !fwin_pForm->mo->qshowCurve;
            break;
            
        case Key_E:
            fwin_pForm->mo->qshowEdge = !fwin_pForm->mo->qshowEdge;
            break;

        case Key_F:
            if(e->state()&&ShiftButton) {
                fwin_pForm->mo->qshowFrame = !fwin_pForm->mo->qshowFrame;
            }
            else {
                fwin_pForm->mo->qshowFace = !fwin_pForm->mo->qshowFace;
            }
            break;

        case Key_G:
            if(e->state()&&ShiftButton) {
            }            
            break;

		case Key_I:
			if(e->state()&&ShiftButton) {
				fwin_pForm->mo->opt_EPSILON += 0.005;
            }
			break;

		case Key_J:
			if(e->state()&&ShiftButton) {
				fwin_pForm->mo->opt_EPSILON -= 0.005;
            }
			break;

        case Key_K:
            break;

        case Key_L:
            fwin_pForm->mo->showLabels = !fwin_pForm->mo->showLabels;
            fwin_pForm->notifyOGLWidgets();
            break;

		case Key_M:
            if(e->state()&&ShiftButton) {
				fwin_pForm->mo->rshowFace = !fwin_pForm->mo->rshowFace;
            }            
			else {
				fwin_pForm->mo->rshowEdge = !fwin_pForm->mo->rshowEdge;
			}
			break;

        case Key_N:
			if(e->state()&&ShiftButton) {
				fwin_pForm->mo->rshowSurfaceNormals = !fwin_pForm->mo->rshowSurfaceNormals;
			}
			else {
				fwin_pForm->mo->qshowNormals = !fwin_pForm->mo->qshowNormals;
			}
            break;

		case Key_O:
			fwin_pForm->mo->qshowOptimPoints = !fwin_pForm->mo->qshowOptimPoints;
			break;

        case Key_P:
            //fwin_pForm->mo->qshowReflectedPoints = !fwin_pForm->mo->qshowReflectedPoints;
			fwin_pForm->mo->rshowSurfacePoints = !fwin_pForm->mo->rshowSurfacePoints;
            break;

        case Key_Q:
            fwin_pForm->calbak_Swap_Frames();
            break;            

        case Key_R:
            if(e->state()&&ShiftButton) {
                fwin_pForm->mo->qshowQuatRings = !fwin_pForm->mo->qshowQuatRings;
            }
            else	
                this->resetApp();
            break;

        case Key_S:
            if(e->state()&&ShiftButton) {
            }
            else {
                fwin_pForm->mo->qshowSphere = !fwin_pForm->mo->qshowSphere;
            }
            break;

        case Key_T:
            fwin_pForm->mo->qshowQuatRingsSurfaceMesh = !fwin_pForm->mo->qshowQuatRingsSurfaceMesh;
            break;

		case Key_U:
			fwin_pForm->mo->flag_opt_first_time = 1;
			break;

        case Key_W:
            fwin_pForm->mo->qwhichQuatComponent = SHOWXYZ;
			fwin_pForm->updateObject();
            break;

        case Key_X:
            fwin_pForm->mo->qwhichQuatComponent = SHOWWYZ;
			fwin_pForm->updateObject();
            break;

        case Key_Y:
            fwin_pForm->mo->qwhichQuatComponent = SHOWWXZ;
			fwin_pForm->updateObject();
            break;

        case Key_Z:
            fwin_pForm->mo->qwhichQuatComponent = SHOWWXY;
			fwin_pForm->updateObject();
            break;
            
        case Key_1:
			//fwin_pForm->mo->optimization();
			fwin_pForm->mo->rshowColorMode = CODE_SOLID_COLOR;
            break;

        case Key_2:
			fwin_pForm->mo->rshowColorMode = CODE_TWO_SIDE;
            break;

        case (Key_3):
			fwin_pForm->mo->rshowColorMode = CODE_DEPTH;
            break;

        case (Key_4):
            break;
            
        case 27 :
        case Key_Escape:
            //if(mb.exec() == QMessageBox::Yes)
                fwin_pForm->exitApp();
            break;
            
        default:
            break;
    }

    fwin_pForm->stateChange();
    updateGL();
	//fwin_pForm->notifyOGLWidgets();
}

//#RENDER
//calbak: RENDERING
//
void OGLWidgetFloating::paintGL					( )
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
    fwin_pForm->stateChange();
    glPushMatrix();
		glTranslatef(Cx, Cy, 0);
		glScalef(m_viewScale, m_viewScale, m_viewScale);
		fwin_pForm->mo->showQuaternionMap();
    glPopMatrix();	

    if(fwin_pForm->mo->showOnScreenHelp)
		showOnScreenText();
}

//#UTILITIES
//calbak: dump screen
//
int OGLWidgetFloating::saveScreenAsBMP			( )
{
    static int	counter = 1;
    char		fname[100];

	//# Make GL Context current
    makeCurrent();

	//# Copy from OpenGL screen buffer
    QImage *tempImage = new QImage( grabFrameBuffer() );

    if ( !tempImage ) {
        fprintf(stderr,"Error! Failed to allocate memory for image\n");
        return false;
    }

    
        /* Open the file */
    if(fwin_pForm->mo->whichFrame == FRENETSERRET)
        sprintf(fname,"./snapshots/quatmap_%d_%d_torus_knot_frenet%01d.bmp",fwin_pForm->mo->m,fwin_pForm->mo->n,counter);
    else if(fwin_pForm->mo->whichFrame == PARALLELTRANSPORT)
        sprintf(fname,"./snapshots/quatmap_%d_%d_torus_knot_parelltrans%01d.bmp",fwin_pForm->mo->m,fwin_pForm->mo->n,counter);

    if ( !tempImage->save( QString(fname), "BMP") ) {
        fprintf(stderr,"Error! Could not save BMP file...\n");
        return false;
    }
    else {
        printf("Saved! Writing out file: %s\n",fname);
        counter++;
    }
	 
	//# Clean memory
	//delete tempImage;

    return true;

}

