#ifndef _OGLWIDGETFLOATING_
#define _OGLWIDGETFLOATING_

#include <qgl.h>
#include "all.h"

class OGLWidgetFloating : public QGLWidget 
{
public:
	OGLWidgetFloating( QWidget* parent, const char* name, QWidget* parentForm );
	~OGLWidgetFloating ( );

public: //VARIABLES
	// world center
	GLfloat			XC, YC, ZC;					//
    int				X,	Y,	dX, dY;				//
    GLfloat			Cx, Cy, Cz;					//
    double			m_viewScale;				//
    int				main_height, main_width;	//
    int     		enable_picking;				//
    float			xCoord[MAX_POINTS];			//
    float			yCoord[MAX_POINTS];			//
    float			zCoord[MAX_POINTS];			//

	// lighting
    GLfloat 		global_light0[4];			//

	// View-port parameters
    float			xMin;						//
    float			xMax;						//
    float			yMin;						//
    float			yMax;						//
    float			zNear;						//
    float			zFar;						//

	// mouse event data handlers
    float			startY;						//
    int				xBegin, xNext;				//
    int				yBegin, yNext;				//
	int				modkey;						//
    int				button;						//
    int				mouseModifiers;				//
	int				mouseButtons;				//

	// mouse: picking data handlers
	int				litVertex;					//
    int				movingPoint;				//


public: //FUNCTIONS
	/* ADMINISTRATION */
	//window operations
	void			initializeGL		( void );					//
	void			init				( void );					//
	void			initLighting		( void );					//
	void			paintGL				( void );					//
	void			resizeGL			( int wd, int ht ); 		//
	void			resetApp			( void );					//
	int				saveScreenAsBMP		( void );

	//event handlers
    void			keyPressEvent			( QKeyEvent *e );		//			
	void			mousePressEvent			( QMouseEvent *e );		//
	void			mouseReleaseEvent		( QMouseEvent *e );		//
	void			moveTransformedCoordinate( float x, float y );	//
	void			mouseMoveEvent			( QMouseEvent *e );		//
	void			mouseDoubleClickEvent	( QMouseEvent *e );		//


};


#endif
